#include "datatypes.h"
#include "math.h"


//////// Fielding ////////

Uint32 getLong(BYTE * Message, const Uint32 Offset)
{
	return *(Uint32*)&(Message[Offset]);
}

Uint16 getShort(BYTE * Message, const Uint32 Offset)
{
	return *(Uint16*)&(Message[Offset]);
}

Uint32 getLong(char * Message, const Uint32 Offset)
{
	return *(Uint32*)&(Message[Offset]);
}

Uint16 getShort(char * Message, const Uint32 Offset)
{
	return *(Uint16*)&(Message[Offset]);
}

BYTE getByte(char * Message, const Uint32 Offset)
{
	return *(BYTE*)&(Message[Offset]);
}


//////// Strings ////////

Uint32 STRLEN(char * string)
{
	Uint32 len = 0;

	while (string[len++]);
	len--;

	return len;
}

String getString(Uint32 number)
{
	char string[11];
	Uint32 i, n,
		   v = 1000000000;

	for (i = 0; i < 11; i++, v /= 10)
	{
		IDIVCOMP(number, v, number, n);
		string[i] = (char)n + '0';
	}

	string[i] = '\0';

	String ret;
	ret.append(string, STRLEN(string));

	return ret;
}

String::String()
{
	msg = new char[1];
	msg[0] = '\0';
	len = 0;
}

String::~String()
{
	delete []msg;
}

void String::append(char * buffer, Uint32 nlen)
{
	Uint32 clen = nlen + len;
	char * temp = new char[clen + 1];
	MEMCPY(msg, temp, len);
	MEMCPY(buffer, temp + len, nlen);
	temp[clen] = '\0';

	delete []msg;
	msg = temp;
	len = clen;
}

void String::clear()
{
	delete []msg;
	msg = new char[1];
	msg[0] = '\0';
	len = 0;
}

void String::operator=(char * string)
{
	clear();

	append(string, STRLEN(string));
}

void String::operator=(Sint32 number)
{
	clear();

	String str = getString(number);
	append(str.msg, str.len);
}

void String::operator=(String string)
{
	clear();

	append(string.msg, string.len);
}

bool String::operator==(char * string)
{
	return false;
}

bool String::operator==(String * string)
{
	return false;
}
