/*
	System-level access by Catid@pacbell.net
*/

#ifndef SYSTEM_H
#define SYSTEM_H

void BotSession::AddNewsChecksum(DWORD Checksum)
{
	// Extract location to write the new checksum
	DWORD Position = getSetting32(HKEY_CURRENT_USER, "Software\\Virgin\\SubSpace\\News", "Pos");

	_string s;
	if (Position < 1000)
		s += "0";
	if (Position < 100)
		s += "0";
	if (Position < 10)
		s += "0";
	s += (int)Position;

	// Write the checksum
	setSetting32(HKEY_CURRENT_USER, "Software\\Virgin\\SubSpace\\News", s.Text, Checksum);

	// Calculate new location to write the next checksum
	Position++;
	if (Position == 10000)
		Position = 0;

	// Write this location to the registry
	setSetting32(HKEY_CURRENT_USER, "Software\\Virgin\\SubSpace\\News", "Pos", Position);
}

#endif	// SYSTEM_H
